//
//  AppDelegate.swift
//  Timer
//
//  Designed by Lech Szymanski in 2014.
//  Swift implementation by David Eyers in 2015.
//  Updated for Swift 4.x / Xcode 9.4 in 2018 by Hamza Bennani.
//

import Cocoa

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate {

    @IBOutlet weak var window: NSWindow!
    
    // Outlets to the menus that we added
    @IBOutlet weak var startMenuItem: NSMenuItem!
    @IBOutlet weak var stopMenuItem: NSMenuItem!

    var timerWindows = [TimerWindowController]()

    override init() {
        super.init()
        // If AppDelegate weren't a singleton, would need to use a Swift dispatch_once block
        let sToTTransformer = SecondsToTimerTransformer()
        let rToTTransformer = RunningToTitleTransformer()
        
        ValueTransformer.setValueTransformer(sToTTransformer, forName: NSValueTransformerName(rawValue: "SecondsToTimerTransformer"))
        ValueTransformer.setValueTransformer(rToTTransformer, forName: NSValueTransformerName(rawValue: "RunningToTitleTransformer"))
    }

    func applicationDidFinishLaunching(_ aNotification: Notification) {
        // Insert code here to initialize your application

        newTimerWindow(self)
    }

    func applicationWillTerminate(_ aNotification: Notification) {
        // Insert code here to tear down your application
    }

    @IBAction func newTimerWindow(_ sender: AnyObject) {
        let timerWindow = TimerWindowController()
        timerWindows.append(timerWindow)
        timerWindow.showWindow(self)
    }

}
