//
//  Transformer.swift
//  Timer
//
//  Designed by Lech Szymanski in 2014.
//  Swift implementation by David Eyers in 2015.
//  Updated for Swift 4.x / Xcode 9.4 in 2018 by Hamza Bennani.
//

import Cocoa

class SecondsToTimerTransformer:ValueTransformer {
    override class func transformedValueClass()->AnyClass {
        return NSNumber.self
    }
    override class func allowsReverseTransformation()->Bool {
        return false
    }
    
    override func transformedValue(_ value: Any?) -> Any? {
        let newValue = (value! as AnyObject).intValue + 11*3600
        return NSNumber(value: newValue as Int)
    }
}

class RunningToTitleTransformer:ValueTransformer {
    override class func transformedValueClass()->AnyClass {
        return NSString.self
    }
    override class func allowsReverseTransformation()->Bool {
        return false
    }

    override func transformedValue(_ value: Any?) -> Any? {
        let running = (value! as AnyObject).boolValue
        if(running!){
            return NSString(utf8String: "Stop")
        }else{
            return NSString(utf8String: "Start")
        }
    }
}
